<html>
<head>
<title>Ogre::FrameListener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1FrameListener.html">FrameListener</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::FrameListener Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::FrameListener" -->
<p>A interface class defining a listener which can be used to receive notifications of frame events.  
 <a href="classOgre_1_1FrameListener.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::FrameListener:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1FrameListener__inherit__graph.gif" border="0" usemap="#Ogre_1_1FrameListener_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1FrameListener_inherit__map" id="Ogre_1_1FrameListener_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1FrameTimeControllerValue.html" title="Predefined controller value for getting the latest frame time." alt="" coords="5,83,219,112"/><area shape="rect" id="node5" href="classOgre_1_1PageManager_1_1EventRouter.html" title="Ogre::PageManager::EventRouter" alt="" coords="243,83,461,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1FrameListener-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FrameListener.html#a88238b65f9ce32f0de8c5eeeb7b6c6ad">frameStarted</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when a frame is about to begin rendering.  <a href="#a88238b65f9ce32f0de8c5eeeb7b6c6ad"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FrameListener.html#a2785cb38589ab9df123fa401cbda31c3">frameRenderingQueued</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over.  <a href="#a2785cb38589ab9df123fa401cbda31c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FrameListener.html#af1d0140678c18a013ac45aa544c00bfd">frameEnded</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called just after a frame has been rendered.  <a href="#af1d0140678c18a013ac45aa544c00bfd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FrameListener.html#a49e2b4fc5a0d0547f908f1dd9f1ac16d">~FrameListener</a> ()</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A interface class defining a listener which can be used to receive notifications of frame events. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A 'listener' is an interface designed to be called back when particular events are called. This class defines the interface relating to frame events. In order to receive notifications of frame events, you should create a subclass of <a class="el" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications of frame events...">FrameListener</a> and override the methods for which you would like to customise the resulting processing. You should then call <a class="el" href="classOgre_1_1Root.html#aed3244a81b1c1cec76c675f8e62d7f5e" title="Registers a FrameListener which will be called back every frame.">Root::addFrameListener</a> passing an instance of this class. There is no limit to the number of frame listeners you can register, allowing you to register multiple listeners for different purposes. Frame events only occur when <a class="el" href="namespaceOgre.html">Ogre</a> is in continuous rendering mode, i.e. after <a class="el" href="classOgre_1_1Root.html#a8eda253befda1255cbfd3b298f62449e" title="Starts / restarts the automatic rendering cycle.">Root::startRendering</a> is called. If the application is doing ad-hoc rendering without entering a rendering loop, frame events are not generated. Note that a frame event occurs once for all rendering targets, not once per target. </dd></dl>

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00082">82</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a49e2b4fc5a0d0547f908f1dd9f1ac16d"></a><!-- doxytag: member="Ogre::FrameListener::~FrameListener" ref="a49e2b4fc5a0d0547f908f1dd9f1ac16d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1FrameListener.html#a49e2b4fc5a0d0547f908f1dd9f1ac16d">Ogre::FrameListener::~FrameListener</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00133">133</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="af1d0140678c18a013ac45aa544c00bfd"></a><!-- doxytag: member="Ogre::FrameListener::frameEnded" ref="af1d0140678c18a013ac45aa544c00bfd" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1FrameListener.html#af1d0140678c18a013ac45aa544c00bfd">Ogre::FrameListener::frameEnded</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called just after a frame has been rendered. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This event happens after all render targets have been fully updated and the buffers switched. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to continue with the next frame, false to drop out of the rendering loop. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a823feb29579d463117fdb0417d49a100">Ogre::PageManager::EventRouter</a>, and <a class="el" href="classOgre_1_1FrameTimeControllerValue.html#a2ee210328604677cb76ba0e4d97bd84a">Ogre::FrameTimeControllerValue</a>.</p>

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00130">130</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2785cb38589ab9df123fa401cbda31c3"></a><!-- doxytag: member="Ogre::FrameListener::frameRenderingQueued" ref="a2785cb38589ab9df123fa401cbda31c3" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1FrameListener.html#a2785cb38589ab9df123fa401cbda31c3">Ogre::FrameListener::frameRenderingQueued</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The usefulness of this event comes from the fact that rendering commands are queued for the GPU to process. These can take a little while to finish, and so while that is happening the CPU can be doing useful things. Once the request to 'flip buffers' happens, the thread requesting it will block until the GPU is ready, which can waste CPU cycles. Therefore, it is often a good idea to use this callback to perform per-frame processing. Of course because the frame's rendering commands have already been issued, any changes you make will only take effect from the next frame, but in most cases that's not noticeable. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to continue rendering, false to drop out of the rendering loop. </dd></dl>

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00119">119</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="a88238b65f9ce32f0de8c5eeeb7b6c6ad"></a><!-- doxytag: member="Ogre::FrameListener::frameStarted" ref="a88238b65f9ce32f0de8c5eeeb7b6c6ad" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1FrameListener.html#a88238b65f9ce32f0de8c5eeeb7b6c6ad">Ogre::FrameListener::frameStarted</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when a frame is about to begin rendering. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This event happens before any render targets have begun updating. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to go ahead, false to abort rendering and drop out of the rendering loop. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#ac2ad1b3783610d5c669f6ebb29a5f866">Ogre::PageManager::EventRouter</a>, and <a class="el" href="classOgre_1_1FrameTimeControllerValue.html#a15caa3fcb86af2036b336a5fa6efd1cd">Ogre::FrameTimeControllerValue</a>.</p>

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00100">100</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:56
</p>
</body>
</html>
